unit agnota; (* anotacoes *)

(*                    A G E N D A                 *)
(*                verso 2.3.3  2001              *)
(*                       OS/2                     *)
(*            por Geraldo M. Fontes Jr.           *)
(*             gfontes@tropical.com.br            *)
(* Este programa pode ser livremente distribuido  *)
(* e modificado segundo os termos da licena GPL. *)

interface

uses crt,
     dos,
     mylib,
     agtelas,
     agoutros;

procedure anota;

implementation

const nome           = 'nota.dat';
      nometemp       = 'nota.tmp';
      linha_inicial  = 1;
      linha_final    = 14;
      coluna_inicial = 1;
      coluna_final   = 64;

type altura  = linha_inicial..linha_final;
     largura = coluna_inicial..coluna_final;
     linha   = array[largura] of char;
     tela    = array[altura] of linha;
     tabs    = array[largura] of boolean;


var f,
    ff         : text;
    t          : tela;
    ponto,
    x,
    y,
    cont       : byte;
    muda,
    volta,
    velho,
    notas_erro,
    endfile    : boolean;
    fdl        : array[altura] of byte;
    coderro    : integer;
    tabstop    : tabs;


procedure localiza_FDL(linha : byte);

var c : integer;

begin
  c:= coluna_final;
  while (c > 0) and (t[linha,c] = ' ') do
    dec(c);        (* a varivel FDL indica a coluna seguinte *)
  fdl[linha]:= c + 1;          (* ao ltimo caracter da linha *)
  if fdl[linha] > coluna_final then      (* ou a coluna final *)
    fdl[linha]:= coluna_final;
end; (* localiza_FDL *)

function gravalinha(l : altura) : boolean; (* Grava uma linha de texto *)

var c    : largura;
    erro : integer;

begin
  c:=1;
  erro:=0;
  while (c <> fdl[l]) and (erro = 0) do
  begin                {$I-}
    write(ff,t[l,c]);  {$I+}
    erro:=ioresult;
    c:=c+1
  end;
  if erro = 0 then
    writeln(ff);
  gravalinha:=not(verificaerro(erro));
end; (* gravalinha *)

function desloca : boolean; (* Cria espao entre duas linhas *)

var l      : altura;
    gravou : boolean;

begin
  gravou:=gravalinha(linha_inicial);
  desloca:=gravou;
  if not gravou then
    exit;
  gotoxy(coluna_inicial,linha_inicial);    (* desloca no vdeo *)
  delline;
  gotoxy(coluna_inicial,y);
  insline;
  for l:=linha_inicial to y-1 do
  begin
    t[l]:=t[l+1];
    fdl[l]:=fdl[l+1];
  end;
  fillchar(t[y],coluna_final,' ');
  x:=1;
end; (* desloca *)

procedure insere(Carac : char); (* Cria espao entre dois caracteres *)

var c : integer;

begin
  if fdl[y] < coluna_final then
  begin
    for c:=fdl[y] downto x do
      t[y,c]:=t[y,c-1];
    t[y,x]:=Carac;
    gotoxy(coluna_inicial,y);
    write(t[y]);
    inc(x);
    gotoxy(x,y);
  end
  else
    beep;
end; (* insere *)

procedure apagaum(c,l : byte);

var I : byte;

begin
  for I:= c to coluna_final do
    if I < coluna_final then
      t[l,I]:=t[l,I+1]
    else
      t[l,I]:=' ';
  if fdl[l] > 1 then
    fdl[l]:=fdl[l]-1;
  gotoxy(1,l);
  write(t[l]);
end; (* apagaum *)

function carregalinha(l:byte) : boolean; (* le uma linha do arquivo *)

var c    : largura;
    erro : integer;

begin
  c:=1;
  erro:=0;
  while (c <= coluna_final) and (not eoln(f)) and (erro = 0) do
  begin               {$I-}
    read(f,t[l,c]);   {$I+}
    erro:=ioresult;
    c:=c+1
  end;
  localiza_fdl(l);
  if erro = 0 then
    readln(f);
  carregalinha:=not(verificaerro(erro));
end; (* carregalinha *)

function apagalinha : boolean;

var l   : altura;
    leu : boolean;

begin
  delline;
  if y < linha_final then
    for l:=y to pred(linha_final) do
    begin
      t[l]:=t[l+1];
      fdl[l]:=fdl[l+1];
    end;
  fillchar(t[linha_final],coluna_final,' ');
  gotoxy(1,linha_final);
  write(t[linha_final]);
  if velho then
  begin
    leu:=carregalinha(linha_final);
    apagalinha:=leu;
    if not leu then
      exit;
    gotoxy(1,linha_final);
    write(t[linha_final]);
  end;
  gotoxy(coluna_inicial,y);
  x:=1;
end; (* apagalinha *)

procedure arranja; (* Transfere parte de uma linha para a anterior *)

var nbytes,
    inicio   : byte;
    contador : byte absolute inicio; (* economia de memria *)

begin
  if (y >= linha_final) or (x < fdl[y]) or (x = coluna_final) then
  begin
    beep;
    exit;
  end;
  if x = 1 then
    nbytes:= coluna_final
  else
    nbytes:= coluna_final - x + 1;
  move(t[y+1],t[y,x],nbytes);
  inicio:= 1;
  while nbytes <= fdl[y+1] do
  begin
    t[y+1,inicio]:= t[y+1,nbytes+1];
    inc(inicio);
    inc(nbytes);
  end;
  if inicio < coluna_final then
    fdl[y+1]:= inicio - 1
  else
    fdl[y+1]:= coluna_final;
  for contador:= fdl[y+1] to coluna_final do
    t[y+1,contador]:= ' ';
  gotoxy(1,y);
  write(t[y]);
  gotoxy(1,y+1);
  write(t[y+1]);
end; (* arranja *)

procedure apagaparte; (* Apaga do cursor at o fim da linha *)

var c : byte;

begin
  for c:= x to fdl[y] do
    t[y,c]:=' ';
  clreol;
end; (* apagaparte *)

procedure mostratela;

var l : byte;

begin
  for l:=linha_inicial to linha_final do
  begin
    gotoxy(1,l);
    write(t[l]);
  end;
end; (* mostratela *)

procedure tabset; (* ajusta parada de tabulao *)
begin
  tabstop[x]:= true;
end; (* tabset *)

procedure tabclear; (* elimina parada de tabulao *)
begin
  tabstop[x]:= false;
end; (* tabclear *)

procedure tabula; (* avanca cursor ate prxima parada de tabulao *)
begin
  inc(x);
  while not tabstop[x] do
    inc(x);
end; (* tabula *)

procedure edita; (* Edita tela de texto *)

var a   : char;
    ins,
    ok  : boolean;

procedure verifica; (* Verifica limites da tela *)
begin
  if x > coluna_final then
  begin
    x:=1;
    inc(y)
  end;
  if x < 1 then
  begin
    x:=coluna_final;
    dec(y)
  end;
  if y > linha_final then
  begin
    y:=linha_final;
    ok:=desloca;
    if ok then
      ok:=apagalinha;
  end;
  if y < linha_inicial then
    y:=linha_inicial;
  localiza_fdl(y);
  end; (* verifica *)

procedure controle(cont:byte); (* Processa caracteres de controle *)
begin
  if cont = 0 then
    cont:=ord(readkey);
  case cont of
    8   : begin                                        (* back-space *)
            dec(x);
            if x < fdl[y] then
              apagaum(x,y);
           end;
    9   : tabula;                                      (* tabulao *)
    11  : begin                                        (* home *)
            x:=1;
            y:=linha_inicial;
          end;
    13  : begin                                        (* enter *)
            x:=coluna_inicial;
            inc(y);
          end;
    14  : ok:=desloca;                                 (* ^N *)
    20  : arranja;                                     (* ^T *)
    25  : if ok then                                   (* ^Y *)
            ok:=apagalinha;
    27  : endfile:=true;                               (* ESC *)
    59  : tabset;                                      (* F1 *)
    60  : tabclear;                                    (* F2 *)
    71  : x:=coluna_inicial;                           (* home *)
    72  : dec(y);                                      (* seta p/ cima *)
    75  : dec(x);                                      (* seta a esquerda *)
    77  : inc(x);                                      (* seta a direita *)
    79  : x:=fdl[y];                                   (* end *)
    80  : inc(y);                                      (* seta p/ baixo *)
    81  : muda:=true;                                  (* page down *)
    82  : begin                                        (* ins *)
            Ins:=not Ins;
            setcursor(ins);
          end;
    83  : if x < fdl[y] then                           (* del *)
            apagaum(x,y);
    115 : x:=x-8;                                      (* ^seta a esquerda *)
    116 : x:=x+8;                                      (* ^seta a direita *)
    117 : y:=linha_final;                              (* ^fim *)
    119 : y:=linha_inicial;                            (* ^home *)
    132 : volta:=true;                                 (* ^page up *)
    200 : apagaparte;                                  (* ^5 *)
  end;
end; (* controle *)

begin
  clrscr;
  ins:=false;
  setcursor(normal);
  mostratela;
  x:=coluna_inicial;
  y:=linha_inicial;
  repeat (* Le teclado *)
    verifica;
    gotoxy(x,y);
    cont:=ord(readkey);
    if not(cont in [0..31,127]) then
    begin
      A:=chr(cont);
      if Ins then
        insere(A)
      else
      begin
        write(A);
        t[y,x]:=A;
        x:=x+1
      end
    end
    else
      controle(cont);
  until muda or endfile or volta or (not ok);
  muda:=false;
end; (* edita *)

procedure limpmat; (* Limpa a matriz de edio *)
begin
  fillchar(fdl,sizeof(fdl),1);
  fillchar(t,sizeof(t),' ');
end; (* limpmat *)

function fecharq : boolean; (* Fecha arquivos *)

var erro : integer;

begin
  if velho then              {$I-}
    erase(f);                {$I+}
  erro:= ioresult;
  if erro = 0 then           {$I-}
  begin                      {$I+}
    close(ff);
    erro:= ioresult;
  end;
  if erro = 0 then
  begin                      {$I-}
    rename(ff,Nome);         {$I+}   (* sempre ocorre erro ao renomear arquivo. aparentemente  bug do compilador *)
    erro:= ioresult;
  end;
  fecharq:=not(verificaerro(erro));
end; (* fecharq *)

function arqtemp : boolean; (* Cria arquivo temporrio *)

var erro : integer;

begin
  assign(ff,nometemp);     {$I-}
  rewrite(ff);             {$I+}
  erro:= ioresult;
  arqtemp:=not(verificaerro(erro));
end; (* arqtemp *)

function gravatela : boolean; (* Grava tela no arquivo temporrio *)

var gravou : boolean;
    l      : byte;

begin
  l:=linha_inicial;
  gravou:=true;
  while (l <= linha_final) and gravou do
  begin
    gravou:=gravalinha(l);
    inc(l);
  end;
  gravatela:=gravou;
end; (* gravatela *)

function carregatela : boolean; (* Carrega tela na matriz de edio *)

var carregou : boolean;
    l        : byte;

begin
  l:=linha_inicial;
  carregou:=true;
  while (l <= linha_final) and carregou do
  begin
    carregou:=carregalinha(l);
    inc(l);
  end;
  carregatela:=carregou;
end; (* carregatela *)

function transfere : boolean; (* Copia arquivo no temporrio *)

var carac : char;
    erro  : integer;

begin
  erro:= 0;
  while velho and (not eof(f)) and (erro = 0) do
  begin                       {$I-}
    read(f,carac);            {$I+}
    erro:=ioresult;
    if erro = 0 then
    begin                     {$I-}
      write(ff,carac);        {$I+}
      erro:=ioresult
    end;
  end;
  if erro = 0 then
    transfere:=fecharq
  else
    transfere:=false;
end; (* transfere *)

function arqnovo : boolean; (* Edita Arquivo novo *)

var ok : boolean;

begin
  if not velho then
    ok:=arqtemp;
  while ok and (not endfile) and (not volta) do
  begin
    limpmat;
    edita;
    ok:= gravatela
  end;
  if ok then
    ok:=fecharq;
  arqnovo:=ok;
end; (* arqnovo *)

function arqvelho : boolean; (* Inicia edio de arquivo j existente *)

var ok : boolean;

begin
  ok:=arqtemp;
  while ok and (not eof(f)) and (not endfile) and (not volta) do
  begin
    limpmat;
    ok:=carregatela;
    edita;
    if ok then
      ok:=gravatela
  end;
  if ok and (not endfile) and (not volta) then
    ok:=arqnovo
  else
    ok:=transfere;
  arqvelho:=ok;
end; (* arqvelho *)

procedure inicia_tabs;
var cont : byte;
begin
  for cont:= 1 to coluna_final do
    tabstop[cont]:= cont mod 9 = 0;
end; (* inicia_tabs *)

procedure anota;

begin
  muda:=false;
  endfile:=false;
  velho:=false;
  inicia_tabs;
  textbackground(black);
  clrscr;
  notas;
  textcolor(white);
  textbackground(lightgray);
  window(9,8,72,22);
  assign(f,nome);
  repeat
    volta:=false;    {$I-}
    reset(f);        {$I+}
    coderro:=ioresult; writeln(coderro);
    case coderro of
      0 : begin                               (* arquivo j existe *)
            velho:=true;
            notas_erro:= not arqvelho
          end;
      2 : notas_erro:= not arqnovo;           (* arquivo no existe ainda *)
      else notas_erro:= verificaerro(coderro) (* erro na abertura do arquivo *)
    end; (* case *)
  until endfile or notas_erro;
  window(1,1,80,25);
  clrscr;
end; (* anota *)

end. (* agnota *)