{
   *****************************************************************
   *                                                               *
   *                         UNIT MYLIB                            *
   *                                                               *
   *     Define rotinas e constantes de uso geral para uso em      *
   *                     qualquer programa                         *
   *                                                               *
   *****************************************************************
}

unit mylib;   { $L-,D-}

interface

uses crt;

const
      null     = #0;
      ff       = #12;
    (* teclas *)
      bs       = #8;
      tab      = #9;
      enter    = #13;
      s_tab    = #15;
      esc      = #27;
      branco   = #32;
      f1       = #59;
      f2       = #60;
      f3       = #61;
      f4       = #62;
      f5       = #63;
      f6       = #64;
      f7       = #65;
      f8       = #66;
      f9       = #67;
      f10      = #68;
      f11      = #133;
      f12      = #134;
      home     = #71;
      fim      = #79;
      esquerda = #75;
      direita  = #77;
      acima    = #72;
      abaixo   = #80; 
      pgup     = #73;
      pgdn     = #81;
      ins      = #82;
      del      = #83; 
   (* teclas windows *)
      win1     = #236; 
      win2     = #237;
      menu     = #238;
      sleep    = #239;
   (* tipo de cursor *)
      normal   = false;
      insercao = true; 
   (* tipo de borda para textWindow *)
      simples  = true;
      dupla    = false;                                

type strdata = string[8];

var esp : byte; (* define caracter Branco para Readstr *)

function maiusc(var strg : string) : string; (* converte uma string p/ maiusculas *) 
function extraiBrancos(texto : string) : string; (* extrai todos os espaos em uma string *)
function sn : boolean; (* retorna TRUE se pressionado "S" e FALSE se "N" *)
function editStr(var st : string; tam : byte) : char; (* edita uma string de tamanho tam *)
procedure textwindow(xmin,ymin,xmax,ymax : byte;tipo_borda : boolean);
procedure readstr(var st : string; tam : byte); (* le uma string de tamanho tam *)
procedure readnum(var num : longint; tam : byte);
procedure entradata(var data : strdata); (* retorna uma string com a data digitada *)
procedure converte(data : strdata; var ano,mes,dia : word); (* converte DATA em dia mes e ano *)
procedure tempo_gasto(hi,mi,si,h,m,s : word); (* mostra tempo decorrido entre hi:mi:si e h:m:s *)
procedure beep;  (* emite um sinal sonoro *)
procedure ledata(var ano,mes,dia : word); (* le uma data pelo teclado *)
procedure nocursor; (* esconde o cursor *)
procedure waitesc;(* aguarda o pressionar da tecla ESC *)
procedure setcursor(tipo_cursor : boolean);


implementation

uses dos;

function maiusc(var strg : string) : string;

var cont,
    tam   : integer;

begin
   tam:=length(strg);
   for cont:=1 to tam do
     case strg[cont] of
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        '' : strg[cont]:='';
        else strg[cont]:=upcase(strg[cont])
     end; (* case *)
  maiusc:= strg;
end; (* maiusc *)  

function extraiBrancos(texto : string) : string;

var contador : integer;
    strAux   : string;

begin
  strAux:='';
  for contador:= 1 to length(texto) do
    if texto[contador] <> ' ' then
      strAux:= strAux + texto[contador];
  extraiBrancos:= strAux;
end; (* extraiBrancos *)

procedure textwindow(xmin,ymin,xmax,ymax : byte;tipo_borda : boolean);

const contorno : array [false..true,1..6] of char =
                      (('','','','','',''),
                       ('','','','','',''));

var c        : byte;

begin
  window(1,1,80,25);
  gotoxy(xmin-1,ymin-1);
  write(contorno[tipo_borda,1]);
  for c:=xmin to xmax do
    write(contorno[tipo_borda,2]);
  write(contorno[tipo_borda,3]);
  gotoxy(xmin-1,ymax+1);
  write(contorno[tipo_borda,4]);
  for c:=xmin to xmax do
    write(contorno[tipo_borda,2]);
  write(contorno[tipo_borda,5]);
  for c:=ymin to ymax do
  begin
    gotoxy(xmin-1,c);
    write(contorno[tipo_borda,6]);
    gotoxy(xmax+1,c);
    write(contorno[tipo_borda,6]);
  end;
  window(xmin,ymin,xmax,ymax);
  clrscr;
end; (* textwindow *)

function sn : boolean;

var c : char;

begin
     repeat
        c:=upcase(readkey);
     until (c='S') or (c='N');
     write(c);
     sn:= c='S';
end; (* sn *)

function editStr(var st : string; tam : byte) : char;
  (* retorna o cdigo da tecla que encerrou a edio *)

var c     : char;
    x,
    y,
    pos,
    fimst : byte;

procedure mostrastring;
var cont : byte;
begin
  gotoxy(x,y);
  write(st);
  for cont:=length(st) to fimst do
    write(chr(esp));
  gotoxy(x+pos-1,y);
end; (* mostrastring *)

procedure apagapalavra;
var espaco : boolean;
begin
  repeat
    espaco:=st[pos] = ' ';
    if pos = length(st)
       then delete(st,pos,1);
    if pos < length(st)
       then delete(st,pos,1);
  until ((st[pos] <> ' ') and espaco) or (pos = succ(length(st)));
end; (* apagapalavra *)

procedure controle(var tecla : char);
begin
     if tecla = null
        then tecla:= readkey;
     case tecla of
          home     : pos:=1;
          fim      : pos:=length(st)+1;
          esquerda : if pos > 1
                       then dec(pos);
          direita  : if pos <= length(st)
                       then inc(pos);
          bs       : if pos > 1 then
                     begin
                       delete(st,pos-1,1);
                       dec(pos)
                     end;
          del      : if pos <= length(st)
                       then delete(st,pos,1);
          ^T       : apagapalavra;
          esc      : begin
                       st:='';
                       mostrastring;
                     end;
     end; (* case *)
end; (* controle *)

begin (* editStr *)
     fimst:=tam-1;
     pos:=length(st) +1;
     x:=wherex;
     y:=wherey;
     repeat
       mostrastring;
       c:=readkey;
       if c in [null,^T,bs,esc,enter,tab,s_tab] then
         controle(c)
       else
         if length(st) < tam then
         begin
           insert(c,st,pos);
           inc(pos);
         end
         else beep;
     until c in [esc,enter,tab,s_tab];
     editStr:= c;
end; (* editStr *)

procedure readstr(var st : string; tam : byte); (* le uma string de tamanho tam *)

var tec : char;
    lin,
    col : integer;

begin
  lin:= whereY;
  col:= whereX;
  repeat      
    gotoxy(col,lin);
    tec:=editStr(st,tam);
  until (tec = enter) or (tec = esc);
end; (* readstr *)

procedure readnum(var num : longint; tam : byte);

var c     : char;
    st    : string;
    x,
    y,
    pos   : byte;
    code  : longint;

procedure mostrastring;

begin
  gotoxy(x,y);
  write(st,' ':tam - length(st));
  gotoxy(x+pos-1,y);
end; (* mostrastring *)

procedure controle(tecla : char);
begin
  if tecla = null
     then tecla:= readkey;
  case tecla of
    home     : pos:=1;
    fim      : pos:=length(st)+1;
    esquerda : if pos > 1
                  then dec(pos);
    direita  : if pos <= length(st)
                  then inc(pos);
    bs       : if pos > 1 then
               begin
                 delete(st,pos-1,1);
                 dec(pos)
               end;
    del      : if pos <= length(st)
                  then delete(st,pos,1);
    esc      : begin
                 st:='';
                 mostrastring;
               end;
  end; (* case *)
end; (* controle *)

function getvalid : char;
var c : char;
begin
  repeat
    c := readkey;
  until (c in ['0'..'9']) or (c in [null,bs,esc,enter]);
  getvalid:= c;
end; (* getvalid *)

begin
  str(num,st);
  pos:=length(st) +1;
  x:=wherex;
  y:=wherey;
  repeat
    mostrastring;
    c:=getvalid;
    case c of
      null,bs,esc : controle(c);
      enter       : ;
      else if length(st) < tam then
           begin
             insert(c,st,pos);
             inc(pos);
           end
           else beep;
    end; (* case *)
  until (c = esc) or (c = enter);
  val(st,num,code);
end; (* readnum *)

procedure entradata(var data : strdata);

var col,
    lin : integer;

function entra(c : integer) : strdata;

const tam = 8;

var x,               (* posio do cursor na string de data - no h barras *)
    pos   : integer; (* posio do cursor na tela - as barras so consideradas *)
    carac : char;
    data  : strdata;

begin (* entra *)
  gotoxy(c,lin);
  pos:= 0;
  data:='00000000';
  x:= 1;
  repeat
    case x of
      1 : pos:= 0;
      2 : pos:= 1;
      3 : pos:= 3;
      4 : pos:= 4;
      5 : pos:= 6;
      6 : pos:= 7;
      7 : pos:= 8;             
      8 : pos:= 9; 
      9 : pos:= 10;
    end; (* case *)     
    gotoxy(c+pos,lin);
    repeat
      carac:=readkey;
    until (carac in ['0'..'9',enter,bs,esquerda,direita]);
    case carac of
      enter    : ;
      bs,
      esquerda : if x > 1 then dec(x);
      direita  : if x < tam then inc(x);
      else       if x <= tam then
                 begin
                   write(carac);
                   data[x]:=carac;
                   inc(x);
                 end;
    end; (* case *)
  until (carac = enter);
  entra:= data;
end; (* entra *)

begin (* entradata *)
  col:= wherex;
  lin:= wherey;
  gotoxy(col,lin);
  write('__/__/____');
  data:= entra(col);
  if data = '00000000' then
    data:= ''; 
end; (* entradata *)

procedure tempo_gasto(hi,mi,si,h,m,s : word);

var difhor,
    difmin,
    difseg,
    tempo_inicial,
    tempo_final,
    tempo_total,
    resto           : word;

   function convseg(h,m,s : word) : word;
   begin
     convseg:=h*3600 + m*60 + s;
   end; (* convseg *)

begin
  tempo_inicial:=convseg(hi,mi,si);
  tempo_final:=convseg(h,m,s);
  tempo_total:=tempo_final - tempo_inicial;
  difhor:= tempo_total div 3600;
  resto:=tempo_total - difhor*3600;
  difmin:= resto div 60;
  difseg:=resto - (difmin*60);
  if difhor <> 0
     then write(difhor:2,' hora(s) ');
  if difmin <> 0
     then write(difmin:2,' minuto(s) ');
  if difseg <> 0
     then write(difseg:2,' segundo(s)');
end; (* tempo_gasto *)

procedure beep;
begin
{$IFDEF VIRTUALPASCAL}
  playsound(425,100);
{$ELSE}
  sound(425); (* No funciona no FreePascal OS/2 *)
{$ENDIF}
end; (* beep *)

procedure converte(data : strdata; var ano,mes,dia : word);

var sano    : string[4];
    smes,
    sdia    : string[2];
    retorno : longint;

begin
  sano:=copy(data,5,4);
  val(sano,ano,retorno);
  smes:=copy(data,3,2);
  val(smes,mes,retorno);
  sdia:=copy(data,1,2);
  val(sdia,dia,retorno);
end; (* converte *)

procedure ledata(var ano,mes,dia : word);

var data          : strdata;
    dia_da_semana : word;
    x,
    y             : integer;

begin
  x:=wherex;
  y:=wherey;
  repeat
    gotoxy(x,y);
    entradata(data);
     converte(data,ano,mes,dia);
  until (dia>=1) and (dia<=31) and (mes>=1) and (mes<=12) or (data='');
  if data  = ''
    then begin
      getdate(ano,mes,dia,dia_da_semana);
      gotoxy(x,y);
      write(dia:2,'/',mes:2,'/',ano:4)
    end;
end; (* ledata *)

procedure waitesc;

var tec : char;

begin
  repeat
    tec:=readkey;
  until tec = esc;
end; (* waitesc *)

procedure nocursor; (* esconde o cursor *)

var at : word;

begin
  at:=textattr; (* salva cores atuais *)
  textcolor(($70 and at) div 16);
  write(' ',bs);
  textattr:=at;  (* restaura cores *)
end; (* nocursor *)

procedure setcursor(tipo_cursor : boolean);

begin
  (* Compatibilidade com DOS *) 
end; (* setcursor *)


initialization
  textcolor(lightgray);
  textbackground(black);
  esp:=ord(branco);
end. (* mylib *)